Index: branches/new_class_id/src/world_entities/bsp_entity.cc
===================================================================
--- branches/new_class_id/src/world_entities/bsp_entity.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/bsp_entity.cc	(revision 9709)
@@ -18,5 +18,7 @@
 #include "util/loading/resource_manager.h"
 
-CREATE_FACTORY(BspEntity, CL_BSP_ENTITY);
+#include "class_id.h"
+NewObjectListDefinitionID(BspEntity, CL_BSP_ENTITY);
+CREATE_FACTORY(BspEntity);
 
 
@@ -51,4 +53,5 @@
 void BspEntity::init()
 {
+  this->registerObject(this, BspEntity::_objectList);
 
   this->bspManager = NULL;
@@ -69,5 +72,4 @@
   if ( File(ResourceManager::getFullName(name)).exists()  ) {
 
-    this->setClassID(CL_BSP_ENTITY, "BspEntity");
     this->bspManager = new BspManager(this);
 
Index: branches/new_class_id/src/world_entities/character_attributes.cc
===================================================================
--- branches/new_class_id/src/world_entities/character_attributes.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/character_attributes.cc	(revision 9709)
@@ -1,5 +1,5 @@
 
 
-/* 
+/*
    orxonox - the future of 3D-vertical-scrollers
 
@@ -18,7 +18,7 @@
 
 #include "character_attributes.h"
-#include "stdincl.h" 
-
-
+
+
+NewObjectListDefinition(CharacterAttributes);
 
 
@@ -27,7 +27,7 @@
    @todo this constructor is not jet implemented - do it
 */
-CharacterAttributes::CharacterAttributes () 
-{
-   this->setClassID(CL_CHARACTER_ATTRIBUTES, "CharacterAttributes");
+CharacterAttributes::CharacterAttributes ()
+{
+  this->registerObject(this, CharacterAttributes::_objectList);
 }
 
@@ -37,5 +37,5 @@
 
 */
-CharacterAttributes::~CharacterAttributes () 
+CharacterAttributes::~CharacterAttributes ()
 {
 }
@@ -97,5 +97,5 @@
 
 /**
- *  sets maximum health 
+ *  sets maximum health
  * @param health
 
@@ -130,5 +130,5 @@
  *  adds shield strength
  * @param strength
-   
+
    there is currently no limit to shieldstrength
  */
@@ -290,5 +290,5 @@
 /*=====================energy=====================*/
 /**
- *  sets the amount of energy 
+ *  sets the amount of energy
  * @param energy
  */
@@ -332,5 +332,5 @@
 
 /**
- *  gets the amount of energy 
+ *  gets the amount of energy
  * @returns energy
  */
@@ -358,5 +358,5 @@
   return this->energyConsumption;
 }
-  
+
 
 /**
Index: branches/new_class_id/src/world_entities/character_attributes.h
===================================================================
--- branches/new_class_id/src/world_entities/character_attributes.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/character_attributes.h	(revision 9709)
@@ -15,4 +15,5 @@
 */
 class CharacterAttributes : public BaseObject {
+    NewObjectListDeclaration(CharacterAttributes);
 
  public:
Index: branches/new_class_id/src/world_entities/creatures/fps_player.cc
===================================================================
--- branches/new_class_id/src/world_entities/creatures/fps_player.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/creatures/fps_player.cc	(revision 9709)
@@ -32,5 +32,5 @@
 
 #include "aabb.h"
-
+#include "bsp_entity.h"
 
 #include "key_mapper.h"
@@ -41,9 +41,10 @@
 
 
-
-CREATE_FACTORY(FPSPlayer, CL_FPS_PLAYER);
+#include "class_id.h"
+NewObjectListDefinitionID(FPSPlayer, CL_FPS_PLAYER);
+CREATE_FACTORY(FPSPlayer);
 
 #include "script_class.h"
-CREATE_SCRIPTABLE_CLASS(FPSPlayer, CL_FPS_PLAYER,
+CREATE_SCRIPTABLE_CLASS(FPSPlayer, FPSPlayer::classID(),
                         addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
                             ->addMethod("getAbsCoorX", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorX))
@@ -85,5 +86,5 @@
 void FPSPlayer::init()
 {
-  this->setClassID(CL_FPS_PLAYER, "FPSPlayer");
+  this->registerObject(this, FPSPlayer::_objectList);
 
   this->bLeft = false;
@@ -166,5 +167,5 @@
 
     //subscribe to collision reaction
-  this->subscribeReaction(CREngine::CR_PHYSICS_FULL_WALK, CL_BSP_ENTITY);
+  this->subscribeReaction(CREngine::CR_PHYSICS_FULL_WALK, BspEntity::classID());
 
   this->initWeapon = false;
Index: branches/new_class_id/src/world_entities/creatures/fps_player.h
===================================================================
--- branches/new_class_id/src/world_entities/creatures/fps_player.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/creatures/fps_player.h	(revision 9709)
@@ -16,4 +16,5 @@
 class FPSPlayer : public Playable
 {
+  NewObjectListDeclaration(FPSPlayer);
 
   public:
Index: branches/new_class_id/src/world_entities/creatures/md2_creature.cc
===================================================================
--- branches/new_class_id/src/world_entities/creatures/md2_creature.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/creatures/md2_creature.cc	(revision 9709)
@@ -37,5 +37,7 @@
 #include "debug.h"
 
-CREATE_FACTORY(MD2Creature, CL_MD2_CREATURE);
+#include "class_id.h"
+NewObjectListDefinitionID(MD2Creature, CL_MD2_CREATURE);
+CREATE_FACTORY(MD2Creature);
 
 /**
@@ -86,5 +88,5 @@
   PRINTF(4)("MD2CREATURE INIT\n");
   //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
-  this->setClassID(CL_MD2_CREATURE, "MD2Creature");
+  this->registerObject(this, MD2Creature::_objectList);
 
   this->toList(OM_GROUP_01);
@@ -95,5 +97,5 @@
   Weapon* wpLeft = new TestGun(1);
   wpLeft->setName("testGun Left");
-  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_CANNON));
+  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate("Cannon"));
 
   cannon->setName("BFG");
@@ -112,5 +114,5 @@
   this->cameraConnNode.addChild(State::getCameraNode());
   State::getCameraTargetNode()->setRelCoor(10,0,0);
- 
+
 
 
Index: branches/new_class_id/src/world_entities/creatures/md2_creature.h
===================================================================
--- branches/new_class_id/src/world_entities/creatures/md2_creature.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/creatures/md2_creature.h	(revision 9709)
@@ -16,4 +16,5 @@
 class MD2Creature : public Playable
 {
+  NewObjectListDeclaration(MD2Creature);
 
   public:
Index: branches/new_class_id/src/world_entities/effects/billboard.cc
===================================================================
--- branches/new_class_id/src/world_entities/effects/billboard.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/effects/billboard.cc	(revision 9709)
@@ -27,6 +27,6 @@
 
 #include "class_id.h"
-CREATE_FACTORY(Billboard, CL_BILLBOARD);
 NewObjectListDefinitionID(Billboard, CL_BILLBOARD);
+CREATE_FACTORY(Billboard);
 
 /**
Index: branches/new_class_id/src/world_entities/effects/explosion.cc
===================================================================
--- branches/new_class_id/src/world_entities/effects/explosion.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/effects/explosion.cc	(revision 9709)
@@ -18,5 +18,5 @@
 #include "explosion.h"
 
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 
 #include "state.h"
@@ -28,6 +28,6 @@
 
 #include "class_id.h"
+NewObjectListDefinitionID(Explosion, CL_EXPLOSION);
 CREATE_FAST_FACTORY_STATIC(Explosion);
-NewObjectListDefinitionID(Explosion, CL_EXPLOSION);
 
 /**
Index: branches/new_class_id/src/world_entities/effects/lightning_bolt.cc
===================================================================
--- branches/new_class_id/src/world_entities/effects/lightning_bolt.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/effects/lightning_bolt.cc	(revision 9709)
@@ -25,7 +25,7 @@
 
 
-
-CREATE_FACTORY(LightningBolt, CL_LIGHTNING_BOLT);
-
+#include "class_id.h"
+NewObjectListDefinitionID(LightningBolt, CL_LIGHTNING_BOLT);
+CREATE_FACTORY(LightningBolt);
 
 /**
@@ -34,5 +34,5 @@
 LightningBolt::LightningBolt (const TiXmlElement* root)
 {
-  this->setClassID(CL_LIGHTNING_BOLT, "LightningBolt");
+  this->registerObject(this, LightningBolt::_objectList);
 
   this->toList(OM_COMMON);
Index: branches/new_class_id/src/world_entities/effects/lightning_bolt.h
===================================================================
--- branches/new_class_id/src/world_entities/effects/lightning_bolt.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/effects/lightning_bolt.h	(revision 9709)
@@ -21,4 +21,5 @@
 class LightningBolt : public WorldEntity
 {
+  NewObjectListDeclaration(LightningBolt);
   public:
     LightningBolt(const TiXmlElement* root = NULL);
Index: branches/new_class_id/src/world_entities/elements/image_entity.cc
===================================================================
--- branches/new_class_id/src/world_entities/elements/image_entity.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/elements/image_entity.cc	(revision 9709)
@@ -30,5 +30,7 @@
 
 
-CREATE_FACTORY(ImageEntity, CL_IMAGE_ENTITY);
+#include "class_id.h"
+NewObjectListDefinitionID(ImageEntity, CL_IMAGE_ENTITY);
+CREATE_FACTORY(ImageEntity);
 
 
@@ -59,5 +61,5 @@
 void ImageEntity::init()
 {
-  this->setClassID(CL_IMAGE_ENTITY, "ImageEntity");
+  this->registerObject(this, ImageEntity::_objectList);
   this->setName("ImageEntity");
 
Index: branches/new_class_id/src/world_entities/elements/image_entity.h
===================================================================
--- branches/new_class_id/src/world_entities/elements/image_entity.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/elements/image_entity.h	(revision 9709)
@@ -21,4 +21,5 @@
 //! A class that enables the
 class ImageEntity : public PNode, public Element2D {
+  NewObjectListDeclaration(ImageEntity);
 
  public:
Index: branches/new_class_id/src/world_entities/elements/text_element.cc
===================================================================
--- branches/new_class_id/src/world_entities/elements/text_element.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/elements/text_element.cc	(revision 9709)
@@ -27,6 +27,7 @@
 
 
-
-CREATE_FACTORY(TextElement, CL_TEXT_ELEMENT);
+#include "class_id.h"
+NewObjectListDefinitionID(TextElement, CL_TEXT_ELEMENT);
+CREATE_FACTORY(TextElement);
 
 
@@ -36,5 +37,5 @@
 TextElement::TextElement (const TiXmlElement* root)
 {
-  this->setClassID(CL_TEXT_ELEMENT, "TextElement");
+  this->registerObject(this, TextElement::_objectList);
   this->setName("TextElement");
 
Index: branches/new_class_id/src/world_entities/elements/text_element.h
===================================================================
--- branches/new_class_id/src/world_entities/elements/text_element.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/elements/text_element.h	(revision 9709)
@@ -21,4 +21,5 @@
 //! A class that enables the
 class TextElement : public Text {
+  NewObjectListDeclaration(TextElement);
 
  public:
Index: branches/new_class_id/src/world_entities/environment.cc
===================================================================
--- branches/new_class_id/src/world_entities/environment.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/environment.cc	(revision 9709)
@@ -22,11 +22,11 @@
 #include "util/loading/resource_manager.h"
 
-#include "vector.h"
 #include "objModel.h"
 #include "obb_tree.h"
 #include "util/loading/factory.h"
 
-
-CREATE_FACTORY(Environment, CL_ENVIRONMENT);
+#include "class_id.h"
+NewObjectListDefinitionID(Environment, CL_ENVIRONMENT);
+CREATE_FACTORY(Environment);
 
 /**
@@ -63,5 +63,5 @@
 void Environment::init()
 {
-  this->setClassID(CL_ENVIRONMENT, "Environment");
+  this->registerObject(this, Environment::_objectList);
   this->toList(OM_ENVIRON);
 }
Index: branches/new_class_id/src/world_entities/environment.h
===================================================================
--- branches/new_class_id/src/world_entities/environment.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/environment.h	(revision 9709)
@@ -16,5 +16,5 @@
 class Environment : public WorldEntity
 {
-  friend class World;
+  NewObjectListDeclaration(Environment);
 
  public:
Index: branches/new_class_id/src/world_entities/environments/building.cc
===================================================================
--- branches/new_class_id/src/world_entities/environments/building.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/environments/building.cc	(revision 9709)
@@ -23,6 +23,7 @@
 
 
-
-CREATE_FACTORY(Building, CL_BUILDING);
+#include "class_id.h"
+NewObjectListDefinitionID(Building, CL_BUILDING);
+CREATE_FACTORY(Building);
 
 /**
@@ -31,5 +32,5 @@
 Building::Building(const TiXmlElement* root)
 {
-  this->setClassID(CL_BUILDING, "Building");
+  this->registerObject(this, Building::_objectList);
   this->toList(OM_ENVIRON_NOTICK);
 
Index: branches/new_class_id/src/world_entities/environments/building.h
===================================================================
--- branches/new_class_id/src/world_entities/environments/building.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/environments/building.h	(revision 9709)
@@ -15,5 +15,6 @@
 class Building : public WorldEntity
 {
- public:
+  NewObjectListDeclaration(Building);
+  public:
   Building(const TiXmlElement* root);
 
Index: branches/new_class_id/src/world_entities/environments/mapped_water.cc
===================================================================
--- branches/new_class_id/src/world_entities/environments/mapped_water.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/environments/mapped_water.cc	(revision 9709)
@@ -25,10 +25,12 @@
 #include "script_class.h"
 
-CREATE_FACTORY(MappedWater, CL_MAPPED_WATER);
+#include "class_id.h"
+NewObjectListDefinitionID(MappedWater, CL_MAPPED_WATER);
+CREATE_FACTORY(MappedWater);
 
 SHELL_COMMAND(gui, MappedWater, toggleGui);
 SHELL_COMMAND(output, MappedWater, saveParams);
 
-CREATE_SCRIPTABLE_CLASS(MappedWater, CL_MAPPED_WATER,
+CREATE_SCRIPTABLE_CLASS(MappedWater, MappedWater::classID(),
                         addMethod("waterUV", ExecutorLua2<MappedWater, float, float>(&MappedWater::fadeWaterUV))
                       ->addMethod("waterFlow", ExecutorLua2<MappedWater, float, float>(&MappedWater::fadeWaterFlow))
@@ -47,5 +49,5 @@
 MappedWater::MappedWater(const TiXmlElement* root)
 {
-  this->setClassID(CL_MAPPED_WATER, "MappedWater");
+  this->registerObject(this, MappedWater::_objectList);
   this->toList(OM_ENVIRON);
 
Index: branches/new_class_id/src/world_entities/environments/mapped_water.h
===================================================================
--- branches/new_class_id/src/world_entities/environments/mapped_water.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/environments/mapped_water.h	(revision 9709)
@@ -35,4 +35,5 @@
 class MappedWater : public WorldEntity
 {
+  NewObjectListDeclaration(MappedWater);
 public:
   MappedWater(const TiXmlElement* root = NULL);
Index: branches/new_class_id/src/world_entities/environments/model_entity.cc
===================================================================
--- branches/new_class_id/src/world_entities/environments/model_entity.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/environments/model_entity.cc	(revision 9709)
@@ -23,6 +23,7 @@
 
 
-
-CREATE_FACTORY(ModelEntity, CL_MODEL_ENTITY);
+#include "class_id.h"
+NewObjectListDefinitionID(ModelEntity, CL_MODEL_ENTITY);
+CREATE_FACTORY(ModelEntity);
 
 /**
@@ -31,5 +32,5 @@
 ModelEntity::ModelEntity(const TiXmlElement* root)
 {
-  this->setClassID(CL_MODEL_ENTITY, "ModelEntity");
+  this->registerObject(this, ModelEntity::_objectList);
   this->toList(OM_ENVIRON);
 
Index: branches/new_class_id/src/world_entities/environments/model_entity.h
===================================================================
--- branches/new_class_id/src/world_entities/environments/model_entity.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/environments/model_entity.h	(revision 9709)
@@ -15,4 +15,5 @@
 class ModelEntity : public WorldEntity
 {
+  NewObjectListDeclaration(ModelEntity);
  public:
   ModelEntity(const TiXmlElement* root);
Index: branches/new_class_id/src/world_entities/environments/water.cc
===================================================================
--- branches/new_class_id/src/world_entities/environments/water.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/environments/water.cc	(revision 9709)
@@ -33,11 +33,12 @@
 
 
-
-CREATE_FACTORY(Water, CL_WATER);
+#include "class_id.h"
+NewObjectListDefinitionID(Water, CL_WATER);
+CREATE_FACTORY(Water);
 
 
 Water::Water(const TiXmlElement* root)
 {
-  this->setClassID(CL_WATER, "Water");
+  this->registerObject(this, Water::_objectList);
   this->toList(OM_ENVIRON);
 
@@ -217,5 +218,5 @@
 void Water::tick(float dt)
 {
-  ObjectManager::EntityList entityList = State::getObjectManager()->getObjectList(OM_GROUP_01_PROJ);
+  ObjectManager::EntityList entityList = State::getObjectManager()->getEntityList(OM_GROUP_01_PROJ);
   ObjectManager::EntityList::iterator entity = entityList.begin();
   while (entity != entityList.end())
Index: branches/new_class_id/src/world_entities/environments/water.h
===================================================================
--- branches/new_class_id/src/world_entities/environments/water.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/environments/water.h	(revision 9709)
@@ -22,5 +22,6 @@
 class Water : public WorldEntity
 {
- public:
+  NewObjectListDeclaration(Water);
+  public:
    Water(const TiXmlElement* root = NULL);
    virtual ~Water();
@@ -38,5 +39,5 @@
    void draw() const;
    void tick(float dt);
-   
+
    virtual void varChangeHandler( std::list<int> & id );
 
@@ -52,5 +53,5 @@
     Material        waterMaterial;
     Shader*         waterShader;
-    
+
     float           height;          //!< The hight of the Water
     int             height_handle;   //!< Handle to notify about changes of height
Index: branches/new_class_id/src/world_entities/movie_entity.cc
===================================================================
--- branches/new_class_id/src/world_entities/movie_entity.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/movie_entity.cc	(revision 9709)
@@ -21,6 +21,7 @@
 
 
-
-CREATE_FACTORY(MovieEntity, CL_MOVIE_ENTITY);
+#include "class_id.h"
+NewObjectListDefinitionID(MovieEntity, CL_MOVIE_ENTITY);
+CREATE_FACTORY(MovieEntity);
 
 /**
@@ -29,5 +30,5 @@
 MovieEntity::MovieEntity (const TiXmlElement* root)
 {
-  this->setClassID(CL_MOVIE_ENTITY, "MovieEntity");
+  this->registerObject(this, MovieEntity::_objectList);
 
   media_container = new MediaContainer();
Index: branches/new_class_id/src/world_entities/movie_entity.h
===================================================================
--- branches/new_class_id/src/world_entities/movie_entity.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/movie_entity.h	(revision 9709)
@@ -14,4 +14,5 @@
 class MovieEntity : public WorldEntity
 {
+  NewObjectListDeclaration(MovieEntity);
   private:
     MediaContainer* media_container;
Index: branches/new_class_id/src/world_entities/npcs/attractor_mine.cc
===================================================================
--- branches/new_class_id/src/world_entities/npcs/attractor_mine.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/attractor_mine.cc	(revision 9709)
@@ -33,7 +33,9 @@
 #include "effects/explosion.h"
 
-CREATE_FACTORY(AttractorMine, CL_ATTRACTOR_MINE);
+#include "class_id.h"
+NewObjectListDefinitionID(AttractorMine, CL_ATTRACTOR_MINE);
+CREATE_FACTORY(AttractorMine);
 #include "script_class.h"
-CREATE_SCRIPTABLE_CLASS(AttractorMine, CL_ATTRACTOR_MINE,
+CREATE_SCRIPTABLE_CLASS(AttractorMine, AttractorMine::classID(),
                         addMethod("setName", ExecutorLua1<BaseObject,const std::string&>(&BaseObject::setName))
                        //Coordinates
@@ -50,5 +52,5 @@
     : NPC(NULL)
 {
-  this->setClassID(CL_ATTRACTOR_MINE, "AttractorMine");
+  this->registerObject(this, AttractorMine::_objectList);
 
   this->toList(OM_GROUP_02);
Index: branches/new_class_id/src/world_entities/npcs/attractor_mine.h
===================================================================
--- branches/new_class_id/src/world_entities/npcs/attractor_mine.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/attractor_mine.h	(revision 9709)
@@ -9,4 +9,5 @@
 
 class AttractorMine : public NPC {
+  NewObjectListDeclaration(AttractorMine);
 
  public:
Index: branches/new_class_id/src/world_entities/npcs/door.cc
===================================================================
--- branches/new_class_id/src/world_entities/npcs/door.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/door.cc	(revision 9709)
@@ -25,11 +25,8 @@
 
 #include "door.h"
-#include "class_list.h"
 
-
-
-
-
-CREATE_FACTORY(Door, CL_DOOR);
+#include "class_id.h"
+NewObjectListDefinitionID(Door, CL_DOOR);
+CREATE_FACTORY(Door);
 
 
@@ -47,6 +44,5 @@
 Door::Door(const TiXmlElement* root)
 {
-
-  this->setClassID(CL_DOOR, "Door");
+  this->registerObject(this, Door::_objectList);
   this->scale = 1.0f;
   this->actionRadius = 1.0;
@@ -152,5 +148,6 @@
 
 
-
+#include "playable.h"
+#include "generic_npc.h"
 /**
  * checks if the door is open
@@ -159,16 +156,13 @@
 {
 
-  std::list<BaseObject*>::const_iterator it;
-  const std::list<BaseObject*>* list = ClassList::getList(CL_PLAYABLE);
   WorldEntity* entity;
   float distance;
 
-  if( list == NULL)
-    return false;
-
+  for (NewObjectList<Playable>::const_iterator it = Playable::objectList().begin();
+       it != Playable::objectList().end();
+       ++it)
   // for all players
-  for( it = list->begin(); it != list->end(); it++)
   {
-    entity = dynamic_cast<WorldEntity*>(*it);
+    entity = (*it);
 
     distance = fabs((this->getAbsCoor() - entity->getAbsCoor()).len());
@@ -178,10 +172,10 @@
 
 
-  list = ClassList::getList(CL_GENERIC_NPC);
-  if( list == NULL)
-    return false;
-  for( it = list->begin(); it != list->end(); it++)
+
+  for (NewObjectList<GenericNPC>::const_iterator it = GenericNPC::objectList().begin();
+       it != GenericNPC::objectList().end();
+       ++it)
   {
-    entity = dynamic_cast<WorldEntity*>(*it);
+    entity = (*it);
 
     distance = fabs((this->getAbsCoor() - entity->getAbsCoor()).len());
Index: branches/new_class_id/src/world_entities/npcs/door.h
===================================================================
--- branches/new_class_id/src/world_entities/npcs/door.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/door.h	(revision 9709)
@@ -21,4 +21,6 @@
 class Door : public WorldEntity
 {
+  NewObjectListDeclaration(Door);
+
   public:
     Door(const TiXmlElement* root = NULL);
Index: branches/new_class_id/src/world_entities/npcs/gate.cc
===================================================================
--- branches/new_class_id/src/world_entities/npcs/gate.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/gate.cc	(revision 9709)
@@ -25,6 +25,4 @@
 
 #include "gate.h"
-#include "class_list.h"
-
 #include "effects/explosion.h"
 
@@ -33,13 +31,14 @@
 
 
-
-CREATE_FACTORY(Gate, CL_GATE);
+#include "class_id.h"
+NewObjectListDefinitionID(Gate, CL_GATE);
+CREATE_FACTORY(Gate);
 
 
 #include "script_class.h"
-CREATE_SCRIPTABLE_CLASS(Gate, CL_GATE,
+CREATE_SCRIPTABLE_CLASS(Gate, Gate::classID(),
                             addMethod("hide", ExecutorLua0<WorldEntity>(&WorldEntity::hide))
                             ->addMethod("unhide", ExecutorLua0<WorldEntity>(&WorldEntity::unhide))
-                            ->addMethod("destroy", ExecutorLua0<Gate>(&Gate::destroy))    
+                            ->addMethod("destroy", ExecutorLua0<Gate>(&Gate::destroy))
                             ->addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
                             ->addMethod("getAbsCoorX", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorX))
@@ -49,4 +48,5 @@
 
 
+
 //! list of all different animations a std md2model supports
 sAnim Gate::animationList[3] =
@@ -62,6 +62,5 @@
 Gate::Gate(const TiXmlElement* root)
 {
-
-  this->setClassID(CL_GATE, "Gate");
+  this->registerObject(this, Gate::_objectList);
   this->scale = 1.0f;
   this->actionRadius = 1.0;
@@ -165,8 +164,8 @@
 void Gate::close()
 {
-  
+
   if( this->destroyed)
     return;
-  
+
   this->setAnimation(GATE_CLOSE, MD2_ANIM_ONCE);
   this->bOpen = false;
@@ -178,13 +177,15 @@
   if( this->destroyed)
     return;
-  
+
   this->setAnimation(GATE_DIE, MD2_ANIM_ONCE);
 
   Explosion::explode(this, Vector(this->getScaling()/160,this->getScaling()/160,this->getScaling()/160));
-  
-  
+
+
   this->destroyed = true;
 }
 
+#include "playable.h"
+#include "generic_npc.h"
 
 /**
@@ -195,15 +196,13 @@
 
   std::list<BaseObject*>::const_iterator it;
-  const std::list<BaseObject*>* list = ClassList::getList(CL_PLAYABLE);
   WorldEntity* entity;
   float distance;
 
-  if( list == NULL)
-    return false;
-
   // for all players
-  for( it = list->begin(); it != list->end(); it++)
-  {
-    entity = dynamic_cast<WorldEntity*>(*it);
+  for (NewObjectList<Playable>::const_iterator it = Playable::objectList().begin();
+       it != Playable::objectList().end();
+       ++it)
+  {
+    entity = (*it);
 
     distance = fabs((this->getAbsCoor() - entity->getAbsCoor()).len());
@@ -213,10 +212,9 @@
 
 
-  list = ClassList::getList(CL_GENERIC_NPC);
-  if( list == NULL)
-    return false;
-  for( it = list->begin(); it != list->end(); it++)
-  {
-    entity = dynamic_cast<WorldEntity*>(*it);
+  for (NewObjectList<GenericNPC>::const_iterator it = GenericNPC::objectList().begin();
+       it != GenericNPC::objectList().end();
+       ++it)
+  {
+    entity = (*it);
 
     distance = fabs((this->getAbsCoor() - entity->getAbsCoor()).len());
Index: branches/new_class_id/src/world_entities/npcs/gate.h
===================================================================
--- branches/new_class_id/src/world_entities/npcs/gate.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/gate.h	(revision 9709)
@@ -22,4 +22,6 @@
 class Gate : public WorldEntity
 {
+  NewObjectListDeclaration(Gate);
+
   public:
     Gate(const TiXmlElement* root = NULL);
Index: branches/new_class_id/src/world_entities/npcs/generic_npc.cc
===================================================================
--- branches/new_class_id/src/world_entities/npcs/generic_npc.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/generic_npc.cc	(revision 9709)
@@ -30,9 +30,12 @@
 #include "loading/resource_manager.h"
 
-
-CREATE_FACTORY(GenericNPC, CL_GENERIC_NPC);
+#include "bsp_entity.h"
+
+#include "class_id.h"
+NewObjectListDefinitionID(GenericNPC, CL_GENERIC_NPC);
+CREATE_FACTORY(GenericNPC);
 
 #include "script_class.h"
-CREATE_SCRIPTABLE_CLASS(GenericNPC, CL_GENERIC_NPC,
+CREATE_SCRIPTABLE_CLASS(GenericNPC, GenericNPC::classID(),
                         // Move
                         addMethod("walkTo", ExecutorLua3<GenericNPC,float,float,float>(&GenericNPC::walkTo))
@@ -81,5 +84,5 @@
 void GenericNPC::init()
 {
-  this->setClassID(CL_GENERIC_NPC, "GenericNPC");
+  this->registerObject(this, GenericNPC::_objectList);
 
   this->toList(OM_GROUP_00);
@@ -92,5 +95,5 @@
 
   // collision reaction registration
-   this->subscribeReaction(CREngine::CR_PHYSICS_GROUND_WALK, CL_BSP_ENTITY);
+  this->subscribeReaction(CREngine::CR_PHYSICS_GROUND_WALK, BspEntity::classID());
 }
 
Index: branches/new_class_id/src/world_entities/npcs/generic_npc.h
===================================================================
--- branches/new_class_id/src/world_entities/npcs/generic_npc.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/generic_npc.h	(revision 9709)
@@ -25,4 +25,5 @@
 class GenericNPC : public NPC
 {
+  NewObjectListDeclaration(GenericNPC);
 
 
Index: branches/new_class_id/src/world_entities/npcs/ground_turret.cc
===================================================================
--- branches/new_class_id/src/world_entities/npcs/ground_turret.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/ground_turret.cc	(revision 9709)
@@ -29,8 +29,8 @@
 #include "effects/explosion.h"
 
+#include "class_id.h"
 
-CREATE_FACTORY(GroundTurret, CL_GROUND_TURRET);
-
-
+NewObjectListDefinitionID(GroundTurret, CL_GROUND_TURRET);
+CREATE_FACTORY(GroundTurret);
 
 
@@ -62,5 +62,5 @@
 void GroundTurret::init()
 {
-  this->setClassID(CL_GROUND_TURRET, "GroundTurret");
+  this->registerObject(this, GroundTurret::_objectList);
   this->loadModel("models/ground_turret_#.obj", 5);
   this->left = NULL;
Index: branches/new_class_id/src/world_entities/npcs/ground_turret.h
===================================================================
--- branches/new_class_id/src/world_entities/npcs/ground_turret.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/ground_turret.h	(revision 9709)
@@ -14,4 +14,5 @@
 class GroundTurret : public NPC
 {
+  NewObjectListDeclaration(GroundTurret);
 
 public:
Index: branches/new_class_id/src/world_entities/npcs/network_turret.cc
===================================================================
--- branches/new_class_id/src/world_entities/npcs/network_turret.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/network_turret.cc	(revision 9709)
@@ -31,7 +31,7 @@
 #include "weapons/aiming_turret.h"
 
-CREATE_FACTORY(NetworkTurret, CL_NETWORK_TURRET);
-
-
+#include "class_id.h"
+NewObjectListDefinitionID(NetworkTurret, CL_NETWORK_TURRET);
+CREATE_FACTORY(NetworkTurret);
 
 
@@ -62,5 +62,5 @@
 void NetworkTurret::init()
 {
-  this->setClassID(CL_NETWORK_TURRET, "NetworkTurret");
+  this->registerObject(this, NetworkTurret::_objectList);
   this->loadModel("models/ground_turret_#.obj", 5);
 
@@ -111,6 +111,6 @@
   ObjectManager::EntityList::iterator entity;
   Vector diffVec;
-  for (entity = State::getObjectManager()->getObjectList((OM_LIST)this->targetGroup).begin();
-       entity != State::getObjectManager()->getObjectList((OM_LIST)this->targetGroup).end();
+  for (entity = State::getObjectManager()->getEntityList((OM_LIST)this->targetGroup).begin();
+       entity != State::getObjectManager()->getEntityList((OM_LIST)this->targetGroup).end();
        entity ++)
   {
Index: branches/new_class_id/src/world_entities/npcs/network_turret.h
===================================================================
--- branches/new_class_id/src/world_entities/npcs/network_turret.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/network_turret.h	(revision 9709)
@@ -14,5 +14,5 @@
 class NetworkTurret : public NPC
 {
-
+  NewObjectListDeclaration(NetworkTurret);
 public:
   NetworkTurret(const TiXmlElement* root = NULL);
Index: branches/new_class_id/src/world_entities/npcs/npc_test.cc
===================================================================
--- branches/new_class_id/src/world_entities/npcs/npc_test.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/npcs/npc_test.cc	(revision 9709)
@@ -31,6 +31,6 @@
 
 #include "class_id.h"
-CREATE_FACTORY(NPC2, CL_NPC_TEST2);
 NewObjectListDefinitionID(NPC2, CL_NPC_TEST2);
+CREATE_FACTORY(NPC2);
 
 NPC2::NPC2(const TiXmlElement* root)
